/// <reference types="node" />
import { EventEmitter } from 'node:events';
import { type Pool as GenericPool } from 'generic-pool';
import type Postgres from 'postgres';
declare type PgPool = {
    database?: string;
    host?: string;
    idleTimeoutMillis?: number;
    max?: number;
    min?: number;
    password?: string;
    port?: number;
    ssl?: boolean;
    user?: string;
};
export declare type BridgetClient = {
    end: () => void;
    off: (eventName: string, listener: (...args: any[]) => void) => void;
    on: (eventName: string, listener: (...args: any[]) => void) => void;
};
export declare const createBridge: (postgres: typeof Postgres) => {
    new (poolConfiguration: PgPool): {
        readonly poolEvents: EventEmitter;
        readonly pool: GenericPool<BridgetClient>;
        connect(): Promise<BridgetClient>;
        _pulseQueue(): void;
        _remove(client: {
            end: () => Promise<void>;
        }): Promise<void>;
        readonly _clients: unknown[];
        readonly idleCount: number;
        off(eventName: string, listener: (...args: any[]) => void): EventEmitter;
        on(eventName: string, listener: (...args: any[]) => void): EventEmitter;
        readonly totalCount: number;
        readonly waitingCount: number;
    };
};
export {};
